diff -uNrd ircd-hybrid-6.4.1/src/channel.c ircd-hyb6.4.1-FDFr5.4/src/channel.c
--- ircd-hybrid-6.4.1/src/channel.c	Sat Aug 23 18:37:35 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/channel.c	Sun Nov 16 16:22:53 2003
@@ -22,7 +22,7 @@
  * These flags can be set in a define if you wish.
  *
  *
- * $Id: channel.c,v 1.245 2003/08/23 22:37:35 ievil Exp $
+ * $Id: channel.c,v 1.12 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "channel.h"
 #include "m_commands.h"
@@ -36,6 +36,7 @@
 #include "numeric.h"
 #include "s_serv.h"       /* captab */
 #include "s_user.h"
+#include "s_conf.h"
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
@@ -183,13 +184,11 @@
   ban->flags = CHFL_BAN;
   ban->next = chptr->banlist;
 
-#ifdef BAN_INFO
 
   ban->value.banptr = (aBan *)MyMalloc(sizeof(aBan));
   ban->value.banptr->banstr = (char *)MyMalloc(strlen(banid)+1);
   (void)strcpy(ban->value.banptr->banstr, banid);
 
-#ifdef USE_UH
   if (IsPerson(cptr))
     {
       ban->value.banptr->who =
@@ -201,22 +200,12 @@
     }
   else
     {
-#endif
       ban->value.banptr->who = (char *)MyMalloc(strlen(cptr->name)+1);
       (void)strcpy(ban->value.banptr->who, cptr->name);
-#ifdef USE_UH
     }
-#endif
 
   ban->value.banptr->when = CurrentTime;
 
-#else
-
-  ban->value.cp = (char *)MyMalloc(strlen(banid)+1);
-  (void)strcpy(ban->value.cp, banid);
-
-#endif  /* #ifdef BAN_INFO */
-
   chptr->banlist = ban;
   chptr->num_bed++;
   return 0;
@@ -253,13 +242,10 @@
   ex->flags = CHFL_EXCEPTION;
   ex->next = chptr->exceptlist;
 
-#ifdef BAN_INFO
-
   ex->value.banptr = (aBan *)MyMalloc(sizeof(aBan));
   ex->value.banptr->banstr = (char *)MyMalloc(strlen(eid)+1);
   (void)strcpy(ex->value.banptr->banstr, eid);
 
-#ifdef USE_UH
   if (IsPerson(cptr))
     {
       ex->value.banptr->who =
@@ -271,22 +257,12 @@
     }
   else
     {
-#endif
       ex->value.banptr->who = (char *)MyMalloc(strlen(cptr->name)+1);
       (void)strcpy(ex->value.banptr->who, cptr->name);
-#ifdef USE_UH
     }
-#endif
 
   ex->value.banptr->when = CurrentTime;
 
-#else
-
-  ex->value.cp = (char *)MyMalloc(strlen(eid)+1);
-  (void)strcpy(ex->value.cp, eid);
-
-#endif  /* #ifdef BAN_INFO */
-
   chptr->exceptlist = ex;
   chptr->num_bed++;
   return 0;
@@ -307,21 +283,13 @@
   if (!banid)
     return -1;
   for (ban = &(chptr->banlist); *ban; ban = &((*ban)->next))
-#ifdef BAN_INFO
     if (irccmp(banid, (*ban)->value.banptr->banstr)==0)
-#else
-      if (irccmp(banid, (*ban)->value.cp)==0)
-#endif
         {
           tmp = *ban;
           *ban = tmp->next;
-#ifdef BAN_INFO
           MyFree(tmp->value.banptr->banstr);
           MyFree(tmp->value.banptr->who);
           MyFree(tmp->value.banptr);
-#else
-          MyFree(tmp->value.cp);
-#endif
           free_link(tmp);
 	  /* num_bed should never be < 0 */
 	  if(chptr->num_bed > 0)
@@ -350,13 +318,9 @@
       {
         tmp = *ex;
         *ex = tmp->next;
-#ifdef BAN_INFO
         MyFree(tmp->value.banptr->banstr);
         MyFree(tmp->value.banptr->who);
         MyFree(tmp->value.banptr);
-#else
-        MyFree(tmp->value.cp);
-#endif
         free_link(tmp);
 	/* num_bed should never be < 0 */
 	if(chptr->num_bed > 0)
@@ -399,13 +363,11 @@
   ie->flags = CHFL_INVEX;
   ie->next = chptr->invexlist;
 
-#ifdef BAN_INFO
 
   ie->value.banptr = (aBan *)MyMalloc(sizeof(aBan));
   ie->value.banptr->banstr = (char *)MyMalloc(strlen(eid)+1);
   (void)strcpy(ie->value.banptr->banstr, eid);
 
-#ifdef USE_UH
   if (IsPerson(cptr))
     {
       ie->value.banptr->who =
@@ -417,22 +379,12 @@
     }
   else
     {
-#endif
       ie->value.banptr->who = (char *)MyMalloc(strlen(cptr->name)+1);
       (void)strcpy(ie->value.banptr->who, cptr->name);
-#ifdef USE_UH
     }
-#endif
 
   ie->value.banptr->when = CurrentTime;
 
-#else
-
-  ie->value.cp = (char *)MyMalloc(strlen(eid)+1);
-  (void)strcpy(ie->value.cp, eid);
-
-#endif  /* #ifdef BAN_INFO */
-
   chptr->invexlist = ie;
   chptr->num_bed++;
   return 0;
@@ -455,13 +407,9 @@
       {
         tmp = *ie;
         *ie = tmp->next;
-#ifdef BAN_INFO
         MyFree(tmp->value.banptr->banstr);
         MyFree(tmp->value.banptr->who);
         MyFree(tmp->value.banptr);
-#else
-        MyFree(tmp->value.cp);
-#endif
         free_link(tmp);
 	/* num_bed should never be < 0 */
 	if(chptr->num_bed > 0)
@@ -671,6 +619,9 @@
 {
   Link  *lp;
 
+  if (IsSLine(cptr))
+	  return 0;
+
 #ifdef JUPE_CHANNEL
 #ifdef OPER_JUPE_BYPASS
   if (MyClient(cptr) && chptr->juped && !IsAnOper(cptr))
@@ -691,9 +642,20 @@
   if (chptr->mode.mode & MODE_NOPRIVMSGS && !lp)
     return (MODE_NOPRIVMSGS);
 
+  if (is_banned(cptr, chptr) == CHFL_BAN)
+    return (MODE_BAN);
+
   return 0;
 }
 
+int IsSLine(struct Client *sptr)
+{
+	if ((find_special_conf(sptr->name,CONF_SLINE)) ||
+	    (sptr->user && (find_special_conf((char *)sptr->user->server,CONF_SLINE))))
+		return 1;
+	return 0;
+}
+
 int     user_channel_mode(struct Client *cptr, struct Channel *chptr)
 {
   Link  *lp;
@@ -731,10 +693,12 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
   if (chptr->mode.limit)
     {
       *mbuf++ = 'l';
-      if (IsMember(cptr, chptr) || IsServer(cptr)
+      if (IsMember(cptr, chptr) || IsServer(cptr) || IsSLine(cptr)
 #ifdef OPERSPY
          || ModeCheat
 #endif
@@ -744,7 +708,7 @@
   if (*chptr->mode.key)
     {
       *mbuf++ = 'k';
-      if (IsMember(cptr, chptr) || IsServer(cptr)
+      if (IsMember(cptr, chptr) || IsServer(cptr) || IsSLine(cptr)
 #ifdef OPERSPY
          || ModeCheat
 #endif
@@ -898,6 +862,11 @@
     sendto_one(cptr, ":%s MODE %s %s %s",
                me.name, chptr->chname, modebuf, parabuf);
 
+  if ((chptr->topic_time != 0)&&(chptr->topic != NULL))
+    sendto_one(cptr, ":%s STOPIC %s %ld %s :%s",
+               me.name, chptr->chname, chptr->topic_time,
+               chptr->topic_nick, chptr->topic);
+
   if(!IsCapable(cptr,CAP_EX))
     return;
 
@@ -1046,7 +1015,7 @@
   int   keychange = 0, limitset = 0;
   int   whatt = MODE_ADD, the_mode = 0;
   int   done_s = NO, done_p = NO;
-  int   done_i = NO, done_m = NO, done_n = NO, done_t = NO;
+  int   done_i = NO, done_m = NO, done_n = NO, done_t = NO, done_c = NO;
   struct Client *who;
   Link  *lp;
   char  *curr = parv[0], c, *arg, plus = '+', *tmpc;
@@ -1065,15 +1034,21 @@
    * lets stick mode/params that only the newer servers will understand
    * into modebuf_new/parabuf_new 
    */
+  /*
+   * EVEN WORSE! Thanks to +c, we have nodebuf_fef <-- for CAP_FDF
+   * -JailBird
+   */
 
   char  modebuf_new[MODEBUFLEN];
   char  parabuf_new[MODEBUFLEN];
+  char  modebuf_fef[MODEBUFLEN];
 
   char  *mbufw = modebuf, *mbuf2w = modebuf2;
   char  *pbufw = parabuf, *pbuf2w = parabuf2;
 
   char  *mbufw_new = modebuf_new;
   char  *pbufw_new = parabuf_new;
+  char  *mbufw_fef = modebuf_fef;
 
   char  modebuf_new2[MODEBUFLEN];
   char  parabuf_new2[MODEBUFLEN];
@@ -1091,10 +1066,10 @@
   chan_op = (user_mode_chan & CHFL_CHANOP);
 
   /* has ops or is a server */
-  ischop = IsServer(sptr) || chan_op;
+  ischop = IsServer(sptr) || chan_op || IsSLine(cptr);
 
   /* is client marked as deopped */
-  isdeop = !ischop && !IsServer(sptr) && (user_mode_chan & CHFL_DEOPPED);
+  isdeop = !ischop && !IsServer(sptr) && !IsSLine(sptr) && (user_mode_chan & CHFL_DEOPPED);
 
   /* is an op or server or remote user on a TS channel */
   isok = ischop || (!isdeop && IsServer(cptr) && chptr->channelts);
@@ -1200,7 +1175,7 @@
             break;
 
           /* no more of that mode bouncing crap */
-          if (!IsMember(who, chptr))
+          if (!IsMember(who, chptr) && !IsSLine(sptr))
             {
               if (MyClient(sptr))
                 sendto_one(sptr, form_str(ERR_USERNOTINCHANNEL), me.name, 
@@ -1214,6 +1189,8 @@
                 break;
 	    }
 
+#if 0
+	  /* No no no. This breaks the hacks! -JailBird */
           /* ignore server-generated MODE +ovh */
           if (IsServer(sptr) && (whatt == MODE_ADD))
             {
@@ -1222,6 +1199,7 @@
                        who->name,sptr->name);
               break;
             }
+#endif
 
           if (c == 'o')
             the_mode = MODE_CHANOP;
@@ -1388,7 +1366,6 @@
                */
               if(isok)
                 {
-#ifdef BAN_INFO
                   for (lp = chptr->exceptlist; lp; lp = lp->next)
                     sendto_one(cptr, form_str(RPL_EXCEPTLIST),
                                me.name, cptr->name,
@@ -1396,13 +1373,6 @@
                                lp->value.banptr->banstr,
                                lp->value.banptr->who,
                                lp->value.banptr->when);
-#else 
-                  for (lp = chptr->exceptlist; lp; lp = lp->next)
-                    sendto_one(cptr, form_str(RPL_EXCEPTLIST),
-                               me.name, cptr->name,
-                               chptr->chname,
-                               lp->value.cp);
-#endif
                   sendto_one(sptr, form_str(RPL_ENDOFEXCEPTLIST),
                              me.name, sptr->name, 
                              chptr->chname);
@@ -1486,7 +1456,6 @@
 
               if(isok)
                 {
-#ifdef BAN_INFO
                   for (lp = chptr->invexlist; lp; lp = lp->next)
                     sendto_one(cptr, form_str(RPL_INVEXLIST),
                                me.name, cptr->name,
@@ -1494,13 +1463,6 @@
                                lp->value.banptr->banstr,
                                lp->value.banptr->who,
                                lp->value.banptr->when);
-#else 
-                  for (lp = chptr->invexlist; lp; lp = lp->next)
-                    sendto_one(cptr, form_str(RPL_INVEXLIST),
-                               me.name, cptr->name,
-                               chptr->chname,
-                               lp->value.cp);
-#endif
                   sendto_one(sptr, form_str(RPL_ENDOFINVEXLIST),
                              me.name, sptr->name, 
                              chptr->chname);
@@ -1584,7 +1546,6 @@
 
               if (errsent(SM_ERR_RPL_B, &errors_sent))
                 break;
-#ifdef BAN_INFO
 #ifdef HIDE_OPS
 	      if(chan_op)
 #endif
@@ -1608,13 +1569,6 @@
 			       "*",0);
 		}
 #endif
-#else 
-              for (lp = chptr->banlist; lp; lp = lp->next)
-                sendto_one(cptr, form_str(RPL_BANLIST),
-                           me.name, cptr->name,
-                           chptr->chname,
-                           lp->value.cp);
-#endif
               sendto_one(sptr, form_str(RPL_ENDOFBANLIST),
                          me.name, sptr->name, 
                          chptr->chname);
@@ -2032,6 +1986,45 @@
             }
           break;
 
+        case 'c' :
+          if (whatt == MODE_QUERY)      /* shouldn't happen. */
+            break;
+          if (!isok)
+            {
+              if (MyClient(sptr) && !errsent(SM_ERR_NOOPS, &errors_sent))
+                sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                           sptr->name, chptr->chname);
+              break;
+            }
+
+          if(MyClient(sptr))
+            {
+              if(done_c)
+                break;
+              else
+                done_c = YES;
+            }
+
+          if(whatt == MODE_ADD)
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+              chptr->mode.mode |= MODE_NOCOLOR;
+              *mbufw_fef++ = '+';
+              *mbufw_fef++ = 'c';
+              len += 2;
+            }
+          else
+            {
+              if (len + 2 >= MODEBUFLEN)
+                break;
+              chptr->mode.mode &= ~MODE_NOCOLOR;
+              *mbufw_fef++ = '-';
+              *mbufw_fef++ = 'c';
+              len += 2;
+            }
+          break;
+
         default:
           if (whatt == MODE_QUERY)
             break;
@@ -2051,10 +2044,11 @@
   ** together and send it along.
   */
 
-  *mbufw = *mbuf2w = *pbufw = *pbuf2w = *mbufw_new = *pbufw_new = *mbufw_new2 = *pbufw_new2 = '\0';
+  *mbufw = *mbuf2w = *pbufw = *pbuf2w = *mbufw_new = *pbufw_new = *mbufw_new2 = *pbufw_new2 = *mbufw_fef = '\0';
 
   collapse_signs(modebuf);
   collapse_signs(modebuf_new);
+  collapse_signs(modebuf_fef);
   collapse_signs(modebuf_new2);
 
   if(*modebuf)
@@ -2083,6 +2077,13 @@
                              sptr->name, chptr->chname,
                              modebuf_new, parabuf_new);
     }
+  if(*modebuf_fef)
+    {
+      sendto_channel_butserv(chptr, sptr, ":%s MODE %s %s",
+                             sptr->name, chptr->chname, modebuf_fef);
+      sendto_match_cap_servs(chptr, cptr, CAP_FDF, ":%s MODE %s %s",
+                             sptr->name, chptr->chname, modebuf_fef);
+    }
                      
   if(*modebuf_new2)
     {
@@ -2345,13 +2346,9 @@
   for(ban = ban_ptr; ban; ban = next_ban)
     {
       next_ban = ban->next;
-#ifdef BAN_INFO
       MyFree(ban->value.banptr->banstr);
       MyFree(ban->value.banptr->who);
       MyFree(ban->value.banptr);
-#else
-      MyFree(ban->value.cp);
-#endif
       free_link(ban);
     }
 }
@@ -2673,7 +2670,8 @@
        * flags will have CHFL_EXCEPTION set
        */
 
-      if (MyConnect(sptr) && (i = can_join(sptr, chptr, key, &flags)))
+      if (MyConnect(sptr) &&
+          (i = can_join(sptr, chptr, key, &flags)))
         {
           sendto_one(sptr,
                     form_str(i), me.name, parv[0], name);
@@ -2739,12 +2737,10 @@
             {
               sendto_one(sptr, form_str(RPL_TOPIC), me.name,
                          parv[0], name, chptr->topic);
-#ifdef TOPIC_INFO
               sendto_one(sptr, form_str(RPL_TOPICWHOTIME),
                          me.name, parv[0], name,
                          chptr->topic_nick,
                          chptr->topic_time);
-#endif
             }
           parv[1] = name;
           (void)m_names(cptr, sptr, 2, parv);
@@ -2914,13 +2910,22 @@
       return(0);
     }
 
+  p = strchr(parv[2],',');
+  if(p)
+    *p = '\0';
+  user = parv[2]; /* strtoken(&p2, parv[2], ","); */
+  if (!(who = find_chasing(sptr, user, &chasing)))
+    {
+      return(0);
+    }
+
   /* You either have chan op privs, or you don't -Dianora */
   /* orabidoo and I discussed this one for a while...
    * I hope he approves of this code, (he did) users can get quite confused...
    *    -Dianora
    */
 
-  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) ) 
+  if (!IsServer(sptr) && !is_chan_op(sptr, chptr) && !IsSLine(sptr)) 
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
@@ -2978,16 +2983,6 @@
        */
     }
 
-  p = strchr(parv[2],',');
-  if(p)
-    *p = '\0';
-  user = parv[2]; /* strtoken(&p2, parv[2], ","); */
-
-  if (!(who = find_chasing(sptr, user, &chasing)))
-    {
-      return(0);
-    }
-
   if (IsMember(who, chptr))
     {
 #ifdef HIDE_OPS
@@ -3258,7 +3253,10 @@
           return 0;
         }
 
-      if (!IsMember(sptr, chptr))
+      if (SecretChannel(chptr) && !IsMember(sptr, chptr) && !IsSLine(sptr))
+#ifdef OPERS_SEE_TOPIC
+        if (!IsAnOper(sptr))
+#endif
         {
           sendto_one(sptr, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
               name);
@@ -3271,21 +3269,20 @@
       if(topic) /* a little extra paranoia never hurt */
         {
           if ((chptr->mode.mode & MODE_TOPICLIMIT) == 0 ||
-               is_chan_op(sptr, chptr))
+               is_chan_op(sptr, chptr) || IsSLine(sptr))
             {
               /* setting a topic */
               /*
                * chptr zeroed
                */
               strncpy_irc(chptr->topic, topic, TOPICLEN);
-#ifdef TOPIC_INFO
               /*
                * XXX - this truncates the topic_nick if
                * strlen(sptr->name) > NICKLEN
                */
-              strncpy_irc(chptr->topic_nick, sptr->name, NICKLEN);
+/*              strncpy_irc(chptr->topic_nick, sptr->name, NICKLEN);*/
+	      ircsprintf(chptr->topic_nick, "%s!%s@%s", sptr->name, sptr->username, sptr->host);
               chptr->topic_time = CurrentTime;
-#endif
               sendto_match_servs(chptr, cptr,":%s TOPIC %s :%s",
                                  parv[0], chptr->chname,
                                  chptr->topic);
@@ -3307,12 +3304,10 @@
               sendto_one(sptr, form_str(RPL_TOPIC),
                          me.name, parv[0],
                          chptr->chname, chptr->topic);
-#ifdef TOPIC_INFO
               sendto_one(sptr, form_str(RPL_TOPICWHOTIME),
                          me.name, parv[0], chptr->chname,
                          chptr->topic_nick,
                          chptr->topic_time);
-#endif
             }
         }
     }
@@ -3326,6 +3321,81 @@
 }
 
 /*
+** m_stopic
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = topic TS
+**      parv[3] = topic author
+**      parv[4] = topic text
+*/
+int     m_stopic(cptr, sptr, parc, parv)
+aClient *cptr, *sptr;
+int     parc;
+char    *parv[];
+{
+        aChannel *chptr = NullChn;
+        time_t  newts;
+        char    *topic = NULL, *name, *author;
+
+        if (!IsServer(sptr))
+                return 0;
+
+	if (parc < 5) {
+		sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+			   me.name, parv[0], "STOPIC");
+		return 0;
+	}
+
+        if (parv[4] == NULL)
+                return 0;
+
+        newts = atol(parv[2]);
+        name = parv[1];
+        author = parv[3];
+
+        if (IsChannelName(name)) {
+                chptr = hash_find_channel(name, NullChn);
+                if (chptr == NULL)
+                        return 0;
+                topic = parv[4];
+        }
+
+/* If the received TS is 0, then clear the topics. -- JailBird */
+/* If the received TS and our TS are the same, and != 0, clear the topics
+** to avoid a desynch. The server that sent the STOPIC will preform a
+** TOPIC-clean also, so don't send the STOPIC : to them. --JailBird */
+        if (((newts == chptr->topic_time) && (newts != 0) &&
+            ((chptr->topic==NULL)||(strcmp(topic, chptr->topic))))||
+            (newts == 0)) {
+                chptr->topic[0] = '\0';
+                chptr->topic_nick[0] = '\0';
+                chptr->topic_time = 0;
+                sendto_serv_butone(sptr,":%s STOPIC %s 0 \0 :",
+                                   me.name, chptr->chname);
+                sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :",
+                                       me.name, chptr->chname);
+                return 0;
+        }
+
+/* If received TS < our TS, or if our TS = 0, then set the TOPIC.
+** NOTE: send_channel_modes doesn't send TS's of 0. --JailBird    */
+        if ((newts < chptr->topic_time)||(chptr->topic_time == 0)) {
+                strncpy_irc(chptr->topic, topic, TOPICLEN+1);
+                strncpy_irc(chptr->topic_nick, author, NICKLEN + USERLEN + HOSTLEN + 3);
+		chptr->topic[TOPICLEN] = '\0';
+		chptr->topic_nick[NICKLEN + USERLEN + HOSTLEN + 3] = '\0';
+                chptr->topic_time = newts;
+                sendto_serv_butone(sptr,":%s STOPIC %s %ld %s :%s",
+                                   me.name, chptr->chname, chptr->topic_time,
+                                   chptr->topic_nick, chptr->topic);
+                sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :%s",
+                                       chptr->topic_nick, chptr->chname,
+                                       chptr->topic);
+        }
+        return 0;
+}
+
+/*
 ** m_invite
 **      parv[0] - sender prefix
 **      parv[1] - user to invite
@@ -3398,7 +3468,7 @@
 
   /* By this point, chptr is non NULL */  
 
-  if (!IsMember(sptr, chptr))
+  if (!IsMember(sptr, chptr) && !IsSLine(sptr))
     {
       if (MyClient(sptr))
         sendto_one(sptr, form_str(ERR_NOTONCHANNEL),
@@ -3418,7 +3488,7 @@
     {
       need_invite = YES;
 
-      if (!is_chan_op(sptr, chptr))
+      if (!is_chan_op(sptr, chptr) && !IsSLine(sptr))
         {
           if (MyClient(sptr))
             sendto_one(sptr, form_str(ERR_CHANOPRIVSNEEDED),
@@ -3597,6 +3667,10 @@
       for (lp = chptr->members; lp; lp = lp->next)
         {
           c2ptr = lp->value.cptr;
+#ifdef OPERS_SEE_INVISIBLE
+          /* Allow IRCops to see invisible users. --Runt */
+          if (!IsAnOper(sptr))
+#endif
           if (IsInvisible(c2ptr) && !IsMember(sptr,chptr))
             continue;
 #ifdef HIDE_OPS
@@ -3833,6 +3907,9 @@
       case 't':
         mode.mode |= MODE_TOPICLIMIT;
         break;
+     case 'c':
+        mode.mode |= MODE_NOCOLOR;
+        break;
       case 'k':
         strncpy_irc(mode.key, parv[4 + args], KEYLEN);
         args++;
@@ -3882,17 +3959,6 @@
 
   oldmode = &chptr->mode;
 
-#ifdef IGNORE_BOGUS_TS
-  if (newts < 800000000)
-    {
-      sendto_realops("*** Bogus TS %lu on %s ignored from %s",
-		     (unsigned long) newts,
-		     chptr->chname,
-		     cptr->name);
-      newts = oldts;
-    }
-#endif
-  
   if (isnew)
     chptr->channelts = tstosend = newts;
   else if (newts == 0 || oldts == 0)
@@ -3905,23 +3971,8 @@
   else if (newts < oldts)
   {
   /* new behaviour, never keep our modes */
-#ifdef TS5
     keep_our_modes = NO;
     chptr->channelts = tstosend = newts;
-    
-/* old behaviour, keep our modes if their sjoin is opless */
-#else
-    if(doesop)
-      keep_our_modes = NO;
-    if(haveops && !doesop)
-    {
-      tstosend = oldts;
-      total_ignoreops++;
-    }
-    else
-      chptr->channelts = tstosend = newts;
-#endif /* TS5 */
-
   }
   else
   {
@@ -3936,20 +3987,8 @@
     else
     {
 #endif
-#ifdef TS5
       keep_new_modes = NO;
       tstosend = oldts;
-#else
-      if(haveops)
-        keep_new_modes = NO;
-      if (doesop && !haveops)
-      {
-	total_hackops++;
-        chptr->channelts = tstosend = newts;
-      }
-      else
-        tstosend = oldts;
-#endif /* TS5 */	
 #ifdef JUPE_CHANNEL
     }
 #endif    
@@ -4035,6 +4074,15 @@
         }
       *mbuf++ = 'i';
     }
+  if((MODE_NOCOLOR & oldmode->mode) && !(MODE_NOCOLOR & mode.mode))
+    {
+      if (what != 1)
+        {
+          *mbuf++ = '+';
+          what = 1;
+        }
+      *mbuf++ = 'c';
+    }
 
   /* This loop unrolled below for speed
    */
@@ -4103,6 +4151,15 @@
           what = -1;
         }
       *mbuf++ = 'i';
+    }
+  if((MODE_NOCOLOR & oldmode->mode) && !(MODE_NOCOLOR & mode.mode))
+    {
+      if (what != -1)
+        {
+          *mbuf++ = '-';
+          what = -1;
+        }
+      *mbuf++ = 'c';
     }
 
   if (oldmode->limit && !mode.limit)
diff -uNrd ircd-hybrid-6.4.1/src/class.c ircd-hyb6.4.1-FDFr5.4/src/class.c
--- ircd-hybrid-6.4.1/src/class.c	Mon Jan 31 19:44:11 2000
+++ ircd-hyb6.4.1-FDFr5.4/src/class.c	Wed Oct 15 20:38:23 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: class.c,v 1.14 2000/02/01 00:44:11 lusky Exp $
+ *   $Id: class.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "class.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/client.c ircd-hyb6.4.1-FDFr5.4/src/client.c
--- ircd-hybrid-6.4.1/src/client.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/client.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: client.c,v 1.78 2003/06/24 03:57:16 ievil Exp $
+ *  $Id: client.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "client.h"
 #include "class.h"
@@ -42,6 +42,7 @@
 #include "s_log.h"
 #include "s_misc.h"
 #include "s_serv.h"
+#include "s_stats.h"
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
@@ -369,7 +370,6 @@
             {
               if(IsPerson(cptr))
                 {
-#ifdef GLINES
                   if( (aconf = find_gkill(cptr,cptr->username)) )
                     {
                       sendto_realops("G-line active for %s",
@@ -407,7 +407,6 @@
                       continue;         /* and go examine next fd/cptr */
                     }
                   else
-#endif
                   if((aconf = find_kill(cptr))) /* if there is a returned
                                                    struct ConfItem.. then kill it */
                     {
@@ -541,6 +540,10 @@
                   sendto_ops("No response from %s, closing link",
                              get_client_name(cptr, MASK_IP));
                 }
+#ifdef ANTI_IP_SPOOF
+                if (!IsRegistered(cptr) && (cptr->name[0]) && (cptr->user))
+                  ServerStats->is_ipspoof++;
+#endif /* ANTI_IP_SPOOF */
               /*
                * this is used for KILL lines with time restrictions
                * on them - send a messgae to the user being killed
diff -uNrd ircd-hybrid-6.4.1/src/dbuf.c ircd-hyb6.4.1-FDFr5.4/src/dbuf.c
--- ircd-hybrid-6.4.1/src/dbuf.c	Sat Dec  8 02:06:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/dbuf.c	Wed Oct 15 20:38:23 2003
@@ -21,7 +21,7 @@
  * see the header file (dbuf.h).
  *
  *
- * $Id: dbuf.c,v 1.19 2001/12/08 07:06:13 lusky Exp $
+ * $Id: dbuf.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "dbuf.h"
 #include "common.h"
diff -uNrd ircd-hybrid-6.4.1/src/dline_conf.c ircd-hyb6.4.1-FDFr5.4/src/dline_conf.c
--- ircd-hybrid-6.4.1/src/dline_conf.c	Fri Dec 14 11:56:36 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/dline_conf.c	Wed Oct 15 20:38:23 2003
@@ -1,7 +1,7 @@
 /*
  * dline_conf.c
  *
- * $Id: dline_conf.c,v 1.42 2001/12/14 16:56:36 db Exp $
+ * $Id: dline_conf.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "dline_conf.h"
 #include "class.h"
diff -uNrd ircd-hybrid-6.4.1/src/fdlist.c ircd-hyb6.4.1-FDFr5.4/src/fdlist.c
--- ircd-hybrid-6.4.1/src/fdlist.c	Mon Dec  3 23:47:45 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/fdlist.c	Wed Oct 15 20:38:23 2003
@@ -3,7 +3,7 @@
  * fdlist.c   maintain lists of certain important fds 
  *
  *
- * $Id: fdlist.c,v 1.11 2001/12/04 04:47:45 androsyn Exp $
+ * $Id: fdlist.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "fdlist.h"
 #include "client.h"  /* struct Client */
diff -uNrd ircd-hybrid-6.4.1/src/fileio.c ircd-hyb6.4.1-FDFr5.4/src/fileio.c
--- ircd-hybrid-6.4.1/src/fileio.c	Sat Dec  8 02:06:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/fileio.c	Wed Oct 15 20:38:22 2003
@@ -4,7 +4,7 @@
  * Copyright (C) 1990 Jarkko Oikarinen and
  *                    University of Oulu, Co Center
  *
- * $Id: fileio.c,v 1.6 2001/12/08 07:06:13 lusky Exp $
+ * $Id: fileio.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
diff -uNrd ircd-hybrid-6.4.1/src/flud.c ircd-hyb6.4.1-FDFr5.4/src/flud.c
--- ircd-hybrid-6.4.1/src/flud.c	Sat Nov 18 14:11:11 2000
+++ ircd-hyb6.4.1-FDFr5.4/src/flud.c	Wed Oct 15 20:38:23 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: flud.c,v 1.5 2000/11/18 19:11:11 lusky Exp $
+ *   $Id: flud.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "flud.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/hash.c ircd-hyb6.4.1-FDFr5.4/src/hash.c
--- ircd-hybrid-6.4.1/src/hash.c	Sat Aug 16 14:41:58 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/hash.c	Wed Oct 15 20:38:23 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: hash.c,v 1.41 2003/08/16 18:41:58 ievil Exp $
+ *  $Id: hash.c,v 1.1.1.2 2003/10/09 02:47:14 jailbird Exp $
  */
 #include "m_commands.h"
 #include "s_conf.h"
diff -uNrd ircd-hybrid-6.4.1/src/irc_string.c ircd-hyb6.4.1-FDFr5.4/src/irc_string.c
--- ircd-hybrid-6.4.1/src/irc_string.c	Sun Dec  9 21:56:28 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/irc_string.c	Wed Oct 15 20:38:22 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: irc_string.c,v 1.10 2001/12/10 02:56:28 jdc Exp $
+ *  $Id: irc_string.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "irc_string.h"
 #include "list.h"
diff -uNrd ircd-hybrid-6.4.1/src/ircd.c ircd-hyb6.4.1-FDFr5.4/src/ircd.c
--- ircd-hybrid-6.4.1/src/ircd.c	Mon Aug 18 02:31:33 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/ircd.c	Wed Oct 15 20:38:23 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd.c,v 1.170 2003/08/18 06:31:33 ievil Exp $
+ * $Id: ircd.c,v 1.4 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "ircd.h"
 #include "channel.h"
@@ -529,6 +529,9 @@
   if (dorehash && !LIFESUX)
     {
       rehash(&me, &me, 1);
+      /* Reload the log file on rehash. -JailBird */
+      close_log();
+      init_log(logFileName);
       dorehash = 0;
     }
   if (doremotd)
@@ -774,9 +777,7 @@
   ConfigFileEntry.dlinefile = CPATH;
 #endif /* DLPATH */
 
-#ifdef GLINES
   ConfigFileEntry.glinefile = GLINEFILE;
-#endif
 
 #ifdef  ZIP_LINKS
   /* Make sure the include files match the library version number. */
diff -uNrd ircd-hybrid-6.4.1/src/ircd_signal.c ircd-hyb6.4.1-FDFr5.4/src/ircd_signal.c
--- ircd-hybrid-6.4.1/src/ircd_signal.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/ircd_signal.c	Wed Oct 15 20:38:23 2003
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd_signal.c,v 1.7 2003/06/24 03:57:16 ievil Exp $
+ * $Id: ircd_signal.c,v 1.1.1.2 2003/10/09 02:47:15 jailbird Exp $
  */
 #include "ircd_signal.h"
 #include "ircd.h"         /* dorehash */
diff -uNrd ircd-hybrid-6.4.1/src/list.c ircd-hyb6.4.1-FDFr5.4/src/list.c
--- ircd-hybrid-6.4.1/src/list.c	Mon Jun 23 23:57:16 2003
+++ ircd-hyb6.4.1-FDFr5.4/src/list.c	Wed Oct 15 20:38:23 2003
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu, Computing Center and Jarkko Oikarinen
  *
- * $Id: list.c,v 1.43 2003/06/24 03:57:16 ievil Exp $
+ * $Id: list.c,v 1.3 2003/10/09 03:49:54 jailbird Exp $
  */
 #include "struct.h"
 #include "blalloc.h"
@@ -53,7 +53,7 @@
    for smaller nets who knows? -Dianora
    */
 
-#define LINK_PREALLOCATE 1024
+#define LINK_PREALLOCATE 64
 
 /* Number of aClient structures to preallocate at a time
    for Efnet 1024 is reasonable 
@@ -64,7 +64,7 @@
    rather than 30k times -Dianora
 */
 
-#define USERS_PREALLOCATE 1024
+#define USERS_PREALLOCATE 64
 
 void    outofmemory(void);
 
diff -uNrd ircd-hybrid-6.4.1/src/listener.c ircd-hyb6.4.1-FDFr5.4/src/listener.c
--- ircd-hybrid-6.4.1/src/listener.c	Tue Dec 11 19:29:13 2001
+++ ircd-hyb6.4.1-FDFr5.4/src/listener.c	Wed Oct 15 20:38:22 2003
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: listener.c,v 1.22 2001/12/12 00:29:13 leeh Exp $
+ *  $Id: listener.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "listener.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.4.1/src/m_admin.c ircd-hyb6.4.1-FDFr5.4/src/m_admin.c
--- ircd-hybrid-6.4.1/src/m_admin.c	Fri Nov 10 21:30:23 2000
+++ ircd-hyb6.4.1-FDFr5.4/src/m_admin.c	Wed Oct 15 20:38:22 2003
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_admin.c,v 1.2 2000/11/11 02:30:23 lusky Exp $
+ *   $Id: m_admin.c,v 1.1.1.1 2003/05/09 01:49:28 jailbird Exp $
  */
 #include "m_commands.h"
 #include "client.h"
